#include <sys/mman.h>
#include <sys/stat.h>
#include "rtld.h"

static void _apply_checksum(Obj_Entry *);

void
apply_checksum(Obj_Entry *first)
{
	Obj_Entry *obj = first;

	Needed_Entry *needed;
		
	_apply_checksum(first);

	for (needed = obj->needed; needed != NULL;
	    needed = needed->next)
		_apply_checksum(needed->obj);
}

static void
_apply_checksum(Obj_Entry *obj)
{
	char buf[33];
	Elf_Ehdr *eh;
	Elf_Phdr *ph, *phlimit;

	eh = (Elf_Ehdr *)obj->mapbase;
	ph = (Elf_Phdr *)(obj->mapbase + eh->e_phoff);
	phlimit = ph + eh->e_phnum;
	for (; ph < phlimit; ph++) {
		if (ph->p_type == PT_NB_CKSUM) {
			memcpy(buf, obj->mapbase + ph->p_offset, 32);
			if (strlen(buf) == 0) {
				MD5File(obj->path, buf);
				if (obj->write) {
					printf("Writing ");
					memcpy(obj->mapbase + ph->p_offset,
					    buf, 32);
					msync(obj->mapbase, obj->textsize,
					    MS_ASYNC);
				} else
					printf("Skipping ");
			}
			printf("MD5 (%s) = %s\n", obj->path, buf);
			break;
		}
	}
}
